/*! \file

 
  
   \author    Stephan Kopf
   
	Lehrstuhl fuer Praktische Informatik IV
	Universitaet Mannheim
	68131 Mannheim
	Germany
	email: kopf@informatik.uni-mannheim.de
	
	 (c) Lehrstuhl fuer Praktische Informatik IV, details in COPYRIGHT.txt
	 
*/

// MoCA includes
#include <SadFeature_mmx.h>
#include <mmx.h>


long int
processSAD2 (const unsigned char *img1Ptr, const unsigned char *img2Ptr, long int yOffset1, long int yOffset2)
{
	volatile long unsigned int mmxerror=0;

	pxor_r2r(mm0,mm0);

	const int blkh=16;
	
	int dv;
	for (dv=0; dv<blkh; dv++) {
	  //const unsigned char* p1 = &img1[y0+dv][x0]; 
	  //const unsigned char* p2 = &img2[y1+dv][x1];
	  
	  __asm__ __volatile__ 
	    (
	     "movq   (%0),%%mm1\n\t"
	     "psadbw (%1),%%mm1\n\t"
	     "paddw  %%mm1,%%mm0\n\t"
	     
	     "movq   8(%0),%%mm2\n\t"
	     "psadbw 8(%1),%%mm2\n\t"
	     "paddw  %%mm2,%%mm0\n\t"
	     
	     : : "r" (img1Ptr), "r" (img2Ptr)
	     );

	  img1Ptr += yOffset1;
	  img2Ptr += yOffset2;
	}
	
	movd_r2m(mm0,mmxerror);
	emms();
	
	return mmxerror;
}

